Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/HiveExperimentClient.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/HiveExperimentClient.cs	(revision 5597)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/HiveExperimentClient.cs	(revision 5599)
@@ -28,7 +28,4 @@
 using HeuristicLab.Core;
 using HeuristicLab.Optimization;
-using HeuristicLab.Services.Hive.Common;
-using HeuristicLab.Services.Hive.Common.DataTransfer;
-using HeuristicLab.Services.Hive.Common.ServiceContracts;
 using HeuristicLab.Tracing;
 
@@ -37,5 +34,4 @@
   using System.IO;
   using HeuristicLab.PluginInfrastructure;
-  using DT = HeuristicLab.Services.Hive.Common.DataTransfer;
 
   /// <summary>
@@ -138,5 +134,5 @@
       InitTimer();
     }
-    public HiveExperimentClient(DT.HiveExperiment hiveExperimentDto)
+    public HiveExperimentClient(HiveExperiment hiveExperimentDto)
       : this() {
       UpdateFromDto(hiveExperimentDto);
@@ -155,5 +151,5 @@
     }
 
-    public void UpdateFromDto(DT.HiveExperiment hiveExperimentDto) {
+    public void UpdateFromDto(HiveExperiment hiveExperimentDto) {
       this.HiveExperimentId = hiveExperimentDto.Id;
       this.Name = hiveExperimentDto.Name;
@@ -163,6 +159,6 @@
     }
 
-    public DT.HiveExperiment ToHiveExperimentDto() {
-      return new DT.HiveExperiment() {
+    public HiveExperiment ToHiveExperimentDto() {
+      return new HiveExperiment() {
         Id = this.HiveExperimentId,
         Name = this.Name,
@@ -278,5 +274,5 @@
           this.progress.Status = "Uploading HiveExperiment...";
 
-          DT.HiveExperiment he = service.GetHiveExperiment(service.AddHiveExperiment(this.ToHiveExperimentDto()));
+          HiveExperiment he = service.GetHiveExperiment(service.AddHiveExperiment(this.ToHiveExperimentDto()));
           this.UpdateFromDto(he);
 
@@ -299,4 +295,6 @@
       string exeFilePath = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "HeuristicLab 3.3.exe");
       string configFileName = Path.GetFileName(ConfigurationManager.OpenExeConfiguration(exeFilePath).FilePath);
+      string configFilePath = ConfigurationManager.OpenExeConfiguration(exeFilePath).FilePath;
+
 
       Plugin configPlugin = new Plugin() {
@@ -307,5 +305,5 @@
       PluginData configFile = new PluginData() {
         FileName = configFileName,
-        Data = File.ReadAllBytes(configFileName)
+        Data = File.ReadAllBytes(configFilePath)
       };
       configPlugin.Id = service.AddPlugin(configPlugin, new List<PluginData> { configFile });
@@ -348,5 +346,5 @@
         hiveJob.Job.Id = service.AddChildJob(parentHiveJob.Job.Id, hiveJob.Job, jobData);
       } else {
-        hiveJob.Job.Id = service.AddJob(hiveJob.Job, jobData, groups);
+        hiveJob.Job.Id = service.AddJob(hiveJob.Job, jobData, groups.ToList());
       }
 
@@ -463,5 +461,6 @@
       }
       if (HiveJob != null) {
-        jobResultPoller = new JobResultPoller(HiveJob, ApplicationConstants.ResultPollingInterval);
+        //TODO: find a better place for ApplicationConstants
+        jobResultPoller = new JobResultPoller(HiveJob, /*ApplicationConstants.ResultPollingInterval*/new TimeSpan(0, 0, 5));
         RegisterResultPollingEvents();
       }
@@ -638,4 +637,5 @@
         //progress.ProgressValue = (double)jobCount / totalJobCount;
 
+
         if (this.HiveJob.Job.DateFinished.HasValue) {
           this.ExecutionTime = this.HiveJob.Job.DateFinished.Value - this.HiveJob.Job.DateCreated;
@@ -674,5 +674,5 @@
       }
     }
-    
+
     private OptimizerJob LoadOptimizerJob(Guid jobId) {
       JobData jobData = ServiceLocator.Instance.CallHiveService(s => s.GetJobData(jobId));
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/HiveExperimentManagerClient.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/HiveExperimentManagerClient.cs	(revision 5597)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/HiveExperimentManagerClient.cs	(revision 5599)
@@ -28,5 +28,4 @@
 namespace HeuristicLab.Clients.Hive {
   using HeuristicLab.Common;
-  using DT = HeuristicLab.Services.Hive.Common.DataTransfer;
 
   [Item("Hive Client", "Connects to Hive and lists all submitted experiments by the current user.")]
@@ -94,5 +93,5 @@
         }
         currentlyUpdating = true;
-        IEnumerable<DT.HiveExperiment> response = ServiceLocator.Instance.CallHiveService(s => s.GetHiveExperiments());
+        IEnumerable<HiveExperiment> response = ServiceLocator.Instance.CallHiveService(s => s.GetHiveExperiments());
         progress.Status = "Populating HiveExperiment list...";
         RefreshExperimentList(response);
@@ -108,6 +107,6 @@
     }
 
-    private void RefreshExperimentList(IEnumerable<DT.HiveExperiment> hiveExperiments) {
-      foreach (DT.HiveExperiment hiveExperimentDto in hiveExperiments) {
+    private void RefreshExperimentList(IEnumerable<HiveExperiment> hiveExperiments) {
+      foreach (HiveExperiment hiveExperimentDto in hiveExperiments) {
         HiveExperimentClient hiveExperiment = GetHiveExperiment(hiveExperimentDto.Id);
         if (hiveExperiment == null) {
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/HiveJobClient.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/HiveJobClient.cs	(revision 5597)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/HiveJobClient.cs	(revision 5599)
@@ -30,5 +30,4 @@
 using HeuristicLab.Optimization;
 using HeuristicLab.PluginInfrastructure;
-using HeuristicLab.Services.Hive.Common.DataTransfer;
 
 namespace HeuristicLab.Clients.Hive {
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/HiveJobDownloader.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/HiveJobDownloader.cs	(revision 5597)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/HiveJobDownloader.cs	(revision 5599)
@@ -4,5 +4,4 @@
 using System.Threading;
 using System.Threading.Tasks;
-using HeuristicLab.Services.Hive.Common.DataTransfer;
 
 namespace HeuristicLab.Clients.Hive {
@@ -40,5 +39,5 @@
             throw t.Exception;
           }
-          if(t.Result != null) 
+          if (t.Result != null)
             results.Add(t.Result.Job.Id, t.Result);
         }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/JobResultPoller.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/JobResultPoller.cs	(revision 5597)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/JobResultPoller.cs	(revision 5599)
@@ -24,5 +24,4 @@
 using System.Threading;
 using HeuristicLab.Common;
-using HeuristicLab.Services.Hive.Common.DataTransfer;
 
 namespace HeuristicLab.Clients.Hive {
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/PluginClient.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/PluginClient.cs	(revision 5597)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/PluginClient.cs	(revision 5599)
@@ -1,4 +1,3 @@
 ﻿using System.Collections.Generic;
-using HeuristicLab.Services.Hive.Common.DataTransfer;
 
 namespace HeuristicLab.Clients.Hive {
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/StateLogItem.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/StateLogItem.cs	(revision 5597)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/StateLogItem.cs	(revision 5599)
@@ -2,5 +2,4 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Services.Hive.Common.DataTransfer;
 
 namespace HeuristicLab.Clients.Hive {
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/HeuristicLab.Clients.Hive-3.4.csproj
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/HeuristicLab.Clients.Hive-3.4.csproj	(revision 5597)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/HeuristicLab.Clients.Hive-3.4.csproj	(revision 5599)
@@ -105,6 +105,9 @@
     <Reference Include="System.Core" />
     <Reference Include="System.Drawing" />
+    <Reference Include="System.Runtime.Remoting" />
     <Reference Include="System.Runtime.Serialization" />
+    <Reference Include="System.Runtime.Serialization.Formatters.Soap" />
     <Reference Include="System.ServiceModel" />
+    <Reference Include="System.ServiceModel.Web" />
     <Reference Include="System.Xml.Linq" />
     <Reference Include="System.Data.DataSetExtensions" />
@@ -139,4 +142,9 @@
     <None Include="Properties\AssemblyInfo.cs.frame" />
     <Compile Include="Exceptions\ServiceClientFactoryException.cs" />
+    <Compile Include="ServiceClients\LightweightJob.cs" />
+    <Compile Include="ServiceClients\ExecutorMessageContainer.cs" />
+    <Compile Include="ServiceClients\MessageContainer.cs" />
+    <Compile Include="ServiceClients\HiveServiceClient.cs" />
+    <Compile Include="ServiceClients\Job.cs" />
     <Compile Include="ServiceLocator.cs" />
     <Compile Include="Properties\Settings.Designer.cs">
@@ -160,8 +168,4 @@
       <Project>{F98A1740-9AC9-4D36-A582-6A2D0D06978D}</Project>
       <Name>HeuristicLab.Hive-3.4</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Services.Hive.Common\3.4\HeuristicLab.Services.Hive.Common-3.4.csproj">
-      <Project>{14424A16-48D4-445E-80BF-DDF617548BBB}</Project>
-      <Name>HeuristicLab.Services.Hive.Common-3.4</Name>
     </ProjectReference>
   </ItemGroup>
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/IServiceLocator.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/IServiceLocator.cs	(revision 5597)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/IServiceLocator.cs	(revision 5599)
@@ -21,5 +21,4 @@
 
 using System;
-using HeuristicLab.Services.Hive.Common.ServiceContracts;
 
 namespace HeuristicLab.Clients.Hive {
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/ExecutorMessageContainer.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/ExecutorMessageContainer.cs	(revision 5599)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/ExecutorMessageContainer.cs	(revision 5599)
@@ -0,0 +1,59 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Common;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Clients.Hive {
+  /// <summary>
+  /// This class is used to communicate from the executor to the core, e.g. 
+  /// if the appdomain should be killed
+  /// </summary>
+  [StorableClass]
+  [Serializable]
+  public class ExecutorMessageContainer<CallbackParameterType> : MessageContainer {
+
+    [Storable]
+    public Action<CallbackParameterType> Callback;
+    public CallbackParameterType CallbackParameter;
+
+    public ExecutorMessageContainer() : base() { }
+
+    public ExecutorMessageContainer(MessageType message, Guid parentJobId, Action<CallbackParameterType> callback)
+      : base(message, parentJobId) {
+      this.Callback = callback;
+    }
+
+    protected ExecutorMessageContainer(ExecutorMessageContainer<CallbackParameterType> original, Cloner cloner)
+      : base(original, cloner) {
+      this.Callback = original.Callback;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ExecutorMessageContainer<CallbackParameterType>(this, cloner);
+    }
+
+    public void execute() {
+      Callback(CallbackParameter);
+    }
+  }
+}
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/GenerateServiceClients.cmd
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/GenerateServiceClients.cmd	(revision 5597)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ServiceClients/GenerateServiceClients.cmd	(revision 5599)
@@ -7,8 +7,10 @@
 
 svcutil.exe ^
-  http://localhost:9000/HiveService/mex ^
+  http://localhost/HiveService.svc?wsdl ^
   /out:HiveServiceClient ^
   /namespace:*,HeuristicLab.Clients.Hive ^
+  /collectionType:System.Collections.Generic.List`1 ^
   /targetClientVersion:Version35 ^
+  /serializable ^
   /enableDataBinding ^
   /config:..\app.config 
@@ -24,5 +26,5 @@
 echo ---------------------------------------------------------------------------------------
 echo.
-echo Generation of OKBService client finished.
+echo Generation of (Hive)OKBService client finished.
 echo *******************************************************************************************
 
